import pygame
from pygame.locals import *
import datetime
import os
import sys

from .toothpick import *
from . import title

SCR_RECT = Rect(0, 0, 960, 540)
TITLE, MAP = range(2)

class Game():
    def __init__(self):
        # 初期化
        pygame.init()
        pygame.display.set_caption(u"耳農場 - トロピカルバージョン -")
        screen = pygame.display.set_mode(SCR_RECT.size)
        pygame.display.set_icon(load_image("resources/image", "icon.png", -1))
        self.game_state = TITLE

        # 各インスタンスの作成
        self.title = title.Title()

        # メインループの開始
        clock = pygame.time.Clock()
        while True:
            clock.tick(60)
            self.update()
            self.draw(screen)
            pygame.display.update()
            self.key_handler()
    
    def update(self):
        if self.game_state == TITLE:
            self.title.update()
    
    def draw(self, screen):
        if self.game_state == TITLE:
            self.title.draw(screen)
    
    def key_handler(self):
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()
            if event.type == KEYDOWN and event.key == K_ESCAPE:
                pygame.quit()
                sys.exit()
            
            # キーハンドラー
            if self.game_state == TITLE:
                self.title_handler(event)
    
    def title_handler(self, event):
        """ タイトル画面のキーハンドラー """
        if event.type == KEYDOWN and event.key == K_SPACE:
            if self.title.pressed == False:
                self.title.pressed = True
            else:
                if self.title.select == 0:
                    # コンティニュー
                    self.game_state = MAP
                elif self.title.select == 1:
                    # ニューゲーム
                    self.game_state = MAP
                elif self.title.select == 2:
                    # やめる
                    pygame.quit()
                    sys.exit()
        elif event.type == KEYDOWN and event.key == K_UP:
            if self.title.pressed == True:
                if self.title.select > 1:
                    self.title.select -= 1
                    self.title.cursor_set()
                elif self.title.select == 1:
                    if self.title.valid == True:
                        self.title.select -= 1
                        self.title.cursor_set()
        elif event.type == KEYDOWN and event.key == K_DOWN:
            if self.title.pressed == True:
                if self.title.select < 2:
                    self.title.select += 1
                    self.title.cursor_set()
        elif event.type == KEYDOWN and event.key == K_m:
            self.title.create_mimi()
